---
title: Symbol.isConcatSpreadable
slug: Web/JavaScript/Reference/Global_Objects/Symbol/isConcatSpreadable
tags:
  - ECMAScript 2015
  - JavaScript
  - Property
  - Symbol
---
<div>{{JSRef}}</div>

<p>The <strong><code>Symbol.isConcatSpreadable</code></strong> well-known symbol is used to configure if an object should be flattened to its array elements when using the {{jsxref("Array.prototype.concat()")}} method.</p>

<div>{{EmbedInteractiveExample("pages/js/symbol-isconcatspreadable.html")}}</div>

<h2 id="Description">Description</h2>

<p>The <code>@@isConcatSpreadable</code> symbol (<code>Symbol.isConcatSpreadable</code>) can be defined as an own or inherited property and its value is a boolean. It can control behavior for arrays and array-like objects:</p>

<ul>
 <li>For array objects, the default behavior is to spread (flatten) elements. <code>Symbol.isConcatSpreadable</code> can avoid flattening in these cases.</li>
 <li>For array-like objects, the default behavior is no spreading or flattening. <code>Symbol.isConcatSpreadable</code> can force flattening in these cases.</li>
</ul>

<p>{{js_property_attributes(0,0,0)}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Arrays">Arrays</h3>

<p>By default, {{jsxref("Array.prototype.concat()")}} spreads (flattens) arrays into its result:</p>

<pre class="brush: js">let alpha = ['a', 'b', 'c'],
let numeric = [1, 2, 3]

let alphaNumeric = alpha.concat(numeric)

console.log(alphaNumeric)  // Result: ['a', 'b', 'c', 1, 2, 3]
</pre>

<p>When setting <code>Symbol.isConcatSpreadable</code> to <code>false</code>, you can disable the default behavior:</p>

<pre class="brush: js">let alpha = ['a', 'b', 'c'],
let numeric = [1, 2, 3]

numeric[Symbol.isConcatSpreadable] = false
let alphaNumeric = alpha.concat(numeric)

console.log(alphaNumeric)  // Result: ['a', 'b', 'c', [1, 2, 3] ]
</pre>

<h3 id="Array-like_objects">Array-like objects</h3>

<p>For array-like objects, the default is to not spread. <code>Symbol.isConcatSpreadable</code> needs to be set to <code>true</code> in order to get a flattened array:</p>

<pre class="brush: js">let x = [1, 2, 3]

let fakeArray = {
  [Symbol.isConcatSpreadable]: true,
  length: 2,
  0: 'hello',
  1: 'world'
}

x.concat(fakeArray)  // [1, 2, 3, "hello", "world"]
</pre>

<div class="notecard note">
<p><strong>Note:</strong> The <code>length</code> property is used to control the number of object properties to be added. In the above example, <code>length:2</code> indicates two properties has to be added.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.isconcatspreadable', 'Symbol.isconcatspreadable')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.isConcatSpreadable")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.concat()")}}</li>
</ul>
